#ifndef __ASM_CURRENT_H
#define __ASM_CURRENT_H

#include <rtdef.h>
#include <rtthread.h>

#ifndef __ASSEMBLY__

/*
 * This only works because "struct thread_info" is at offset 0 from "struct
 * task_struct".  This constraint seems to be necessary on other architectures
 * as well, but __switch_to enforces it.  We can't check TASK_TI here because
 * <asm/asm-offsets.h> includes this, and I can't get the definition of "struct
 * task_struct" here due to some header ordering problems.
 */
static __always_inline rt_thread_t get_current(void)
{
    rt_thread_t cur;

    register unsigned long *tp __asm__("tp");
    cur = rt_container_of(tp, struct rt_thread, sp);
    return cur;
}

#define current get_current()

#endif /* __ASSEMBLY__ */

#endif /* __ASM_CURRENT_H */
