/*
 * =====================================================================================
 *
 *       Filename:  stack_init.c
 *
 *    Description:  RISCV Processor C-ABI thread stack init.
 *
 *        Version:  Melis3.0
 *         Create:  2017-11-02 11:58:23
 *       Revision:  none
 *       Compiler:  gcc version 6.3.0 (crosstool-NG crosstool-ng-1.23.0)
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2021-01-26 11:00:43
 *
 * =====================================================================================
 */

#include <stdio.h>
#include <string.h>
#include <misa.h>
#include <kconfig.h>
#include <stdio.h>

void decode_misa(unsigned long misa)
{
    unsigned long mxl_val;
    char *misa_mxl[] =
    {
        "INVAL_ISA",
        "32BIT_ISA",
        "64BIT_ISA",
        "128BIT_ISA"
    };
#ifdef CONFIG_64BIT
    mxl_val = misa >> 62;
#else
    mxl_val = misa >> 30;
#endif
    printf("%s Support:\n\r", misa_mxl[mxl_val]);

    if (misa & RVI)
    {
        printf("I ");
    }

    if (misa & RVE)
    {
        printf("E ");
    }

    if (misa & RVM)
    {
        printf("M ");
    }

    if (misa & RVA)
    {
        printf("A ");
    }

    if (misa & RVF)
    {
        printf("F ");
    }

    if (misa & RVD)
    {
        printf("D ");
    }

    if (misa & RVC)
    {
        printf("C ");
    }

    if (misa & RVS)
    {
        printf("S ");
    }
    if (misa & RVU)
    {
        printf("U ");
    }
    if (misa & RVH)
    {
        printf("H ");
    }
    printf("\n\r");
}
