/*
 * ===========================================================================================
 *
 *       Filename:  timer.c
 *
 *    Description:  tick impl.
 *
 *        Version:  Melis3.0
 *         Create:  2020-06-29 13:59:33
 *       Revision:  none
 *       Compiler:  GCC:version 7.2.1 20170904 (release),ARM/embedded-7-branch revision 255204
 *
 *         Author:  caozilong@allwinnertech.com
 *   Organization:  BU1-PSW
 *  Last Modified:  2021-02-01 08:43:44
 *
 * ===========================================================================================
 */
#include <csr.h>
#include <sbi.h>
#include <timex.h>
#include <irqflags.h>
#include <stdio.h>
#include <debug.h>
#include <FreeRTOSConfig.h>

//24M HZ
void awos_arch_tick_increase(void);
void sunxi_program_timer_next_event(unsigned long next_compare);
uint64_t sunxi_clic_read_mtime(void);
static unsigned long delta = configCPU_CLOCK_HZ / CONFIG_HZ;

void system_tick_init(void)
{
    csr_set(mie, MIE_MTIE);
    sunxi_program_timer_next_event(get_cycles64() + delta);
    csr_clear(mip, SIE_STIE);
    csr_set(mie, MIE_MTIE);
}

void riscv_timer_interrupt(void)
{
    /*
     *DBG("counter3: %lx,counter4: %lx, dcr: 0x%lx, dcrm: 0x%lx dcw: 0x%lx, dcwm: 0x%lx, sto:0x%lx\n", \
     *        csr_read(mhpmcounter3), csr_read(mhpmcounter4), csr_read(mhpmcounter14),csr_read(mhpmcounter15), csr_read(mhpmcounter16), csr_read(mhpmcounter17),csr_read(mhpmcounter13));
     */
    csr_clear(mie, MIE_MTIE);
    sunxi_program_timer_next_event(get_cycles64() + delta);
    csr_set(mie, MIE_MTIE);
}
